#include "includes.h"
#include "ListView.h"
#include <stdio.h>

BOOL LV_Create(HWND hwndParent)
{
	
	RECT rcl;           //   
	HICON hIcon;        //  
	int index;          //   
	HIMAGELIST hSmall, hLarge; //   
	LV_COLUMN lvC;      //     
	char szText[100];    // ,   
    int iWidth;         //  



//  
	iWidth = (rcl.right - rcl.left) - ((rcl.right - rcl.left)/4);
	GetClientRectangle(hwndParent, &rcl);
	HANDLES.hWndListView = CreateWindowEx( 0L,
		WC_LISTVIEW,                
		"",                         
		WS_VISIBLE | WS_CHILD | WS_BORDER | LVS_ICON | WS_EX_CLIENTEDGE,
        (rcl.right - rcl.left)/4, rcl.top,
        iWidth, rcl.bottom - rcl.top - 42,
		hwndParent,
		(HMENU) ID_LISTVIEW,
		HANDLES.hInst,
		NULL );

	if (HANDLES.hWndListView== NULL )
		return NULL;
	

	//   .
    // TRUE -  ; FALSE -  .
	hSmall = ImageList_Create( 16, 16, TRUE, 1, 0 );
	hLarge = ImageList_Create( 32, 32, FALSE, 1, 0 );

 	//    
    hIcon = LoadIcon( HANDLES.hInst, MAKEINTRESOURCE(IDI_ALBUM));
    if ((ImageList_AddIcon(hSmall, hIcon) == -1) ||
        (ImageList_AddIcon(hLarge, hIcon) == -1))
    {
        MessageBox(NULL, "ImageList_AddIcon failed!", NULL, MB_OK);
        return NULL;
    }

	//     .
	ListView_SetImageList(HANDLES.hWndListView, hSmall, LVSIL_SMALL);
	ListView_SetImageList(HANDLES.hWndListView, hLarge, LVSIL_NORMAL);

	//     .
	GetClientRect(HANDLES.hWndMain,&rcl);

	lvC.mask = LVCF_FMT | LVCF_WIDTH | LVCF_TEXT | LVCF_SUBITEM;
	lvC.fmt = LVCFMT_LEFT;  
    lvC.cx = 3*(rcl.right-rcl.left)/16+ 1;
	lvC.pszText = szText;

	//  
    for (index = 0; index < 4; index++)
	{
		lvC.iSubItem = index;
		LoadString( HANDLES.hInst, 
					IDS_TRACK+index,
					szText,
					sizeof(szText));
		if (ListView_InsertColumn(HANDLES.hWndListView, index, &lvC) == -1)
			return NULL;
	}
	return TRUE;
}

BOOL LV_AddItem(HWND hWndList, int index, TCHAR *txt,WorkRecord *param )
{
	//    
	LV_ITEM lvI;        
	int iSubItem;       

   
	lvI.mask = LVIF_TEXT | LVIF_IMAGE | LVIF_PARAM | LVIF_STATE;
    lvI.state = 0;      
    lvI.stateMask = 0;  
    lvI.iItem = index;
    lvI.iSubItem = 0;

   
    lvI.pszText = LPSTR_TEXTCALLBACK; 
    lvI.cchTextMax = 200;
    lvI.iImage = 0;
    lvI.lParam = (LPARAM)param;
//  
    if (ListView_InsertItem(hWndList, &lvI) == -1)
        return FALSE;

    //      
    for (iSubItem = 0; iSubItem < 4; iSubItem++)
    {
        ListView_SetItemText( hWndList,
				index,
				iSubItem,
				LPSTR_TEXTCALLBACK);
	}
    return TRUE;
}

VOID LV_RemoveOneItem(HWND hwndList, int index)
{
    ListView_DeleteItem( hwndList, index);
}

VOID LV_RemoveAllItems( HWND hwndList)
{
    ListView_DeleteAllItems( hwndList);
}

VOID LV_ChangeView(WORD wCommand)
{
    DWORD dwStyle;

    switch (wCommand)
    {
        case IDM_VIEW_BIG:
            dwStyle = GetWindowLong(HANDLES.hWndListView, GWL_STYLE);		
            if ((dwStyle & LVS_TYPEMASK) != LVS_ICON)
                SetWindowLong(HANDLES.hWndListView, GWL_STYLE,  
                   (dwStyle & ~LVS_TYPEMASK) | LVS_ICON);
            break;
        case IDM_VIEW_SMALL:
            dwStyle = GetWindowLong(HANDLES.hWndListView, GWL_STYLE);
        
            if ((dwStyle & LVS_TYPEMASK) != LVS_SMALLICON)
                SetWindowLong(HANDLES.hWndListView, GWL_STYLE,
                   (dwStyle & ~LVS_TYPEMASK) | LVS_SMALLICON);
            break;
        case IDM_VIEW_LIST:
            dwStyle = GetWindowLong(HANDLES.hWndListView, GWL_STYLE);

            if ((dwStyle & LVS_TYPEMASK) != LVS_LIST)
                SetWindowLong(HANDLES.hWndListView, GWL_STYLE,
                   (dwStyle & ~LVS_TYPEMASK) | LVS_LIST);
            break;
        case IDM_VIEW_TABLE:
            dwStyle = GetWindowLong(HANDLES.hWndListView, GWL_STYLE);
            if ((dwStyle & LVS_TYPEMASK) != LVS_REPORT)
                SetWindowLong(HANDLES.hWndListView, GWL_STYLE,
                   (dwStyle & ~LVS_TYPEMASK) | LVS_REPORT);
            break;
    }
}

	static int direction=-1;

LRESULT LV_NotifyHandler( HWND hWnd, UINT uMsg, WPARAM wParam, LPARAM lParam)
{
	LV_DISPINFO *pLvdi = (LV_DISPINFO *)lParam;
	NM_LISTVIEW *pNm = (NM_LISTVIEW *)lParam;
	WorkRecord *pWkRec = (WorkRecord *)(pLvdi->item.lParam);
	static char szText[100];

	if (wParam != ID_LISTVIEW)
		return 0L;

	switch(pLvdi->hdr.code)
	{

		case LVN_GETDISPINFO:
			GetStateOfCommonControls();
			switch (pLvdi->item.iSubItem)
			{
				case 0:     // 
					pLvdi->item.pszText = pWkRec->cTrack;
					break;
				case 1:     //
					pLvdi->item.pszText = pWkRec->cSinger;
					break;

				case 3:     // 
					//sprintf(szText, "$%u", pHouse->iPrice);
					pLvdi->item.pszText = pWkRec->cPlace;
					break;

				case 2:     //  
					//sprintf(szText, "%u", pWkRec->cPlace);
					pLvdi->item.pszText = pWkRec->cDate;
					break;

				default:
					break;
			}
			break;
	     case LVN_COLUMNCLICK:

         //       
         //     
		if(direction==-1) direction=1;
		else direction=-1;

         ListView_SortItems(pNm->hdr.hwndFrom, ListViewCompareProc,
         (LPARAM)(pNm->iSubItem));
         break;
		
    
		default:
			break;
	}
	return 0L;
}


int CALLBACK ListViewCompareProc(LPARAM lParam1, LPARAM lParam2,
LPARAM lParamSort)
{

WorkRecord *pRec1 = (WorkRecord *)lParam1;

WorkRecord *pRec2 = (WorkRecord *)lParam2;

int iResult,nResult;

//MessageBox(NULL,toString(direction),"",NULL);

if (pRec1 && pRec2)

{
	 switch(lParamSort)
     {
		case 0: //   

         iResult = lstrcmpi(pRec1->cTrack, pRec2->cTrack);
         break;
         case 1: //   

              iResult = lstrcmpi(pRec1->cSinger, pRec2->cSinger);

              break;

         case 3: //   

              iResult = lstrcmpi(pRec1->cPlace, pRec2->cPlace);

              break;

         case 2: //   
					
			  iResult=lstrcmpi(pRec1->cDate,pRec2->cDate);
              break;
         default:
              iResult = 0;
	          break;
         }
     }
	if(direction==1){
		if(iResult<0) nResult=1;
		if(iResult==0) nResult=0;
		if(iResult>0) nResult=-1;}

	if(direction==-1){
		if(iResult<0) nResult=-1;
		if(iResult==0) nResult=0;
		if(iResult>0) nResult=1;}

	return(nResult);
}



