#include "includes.h"
#include "TreeView.h"


TVINSERTSTRUCT tviRec;
HTREEITEM hTRoot, hTWork, hTPrev, hParent, hSelected;

BOOL TV_Create(HWND hwndParent)
{
	//   
	RECT rcl; 
	GetClientRectangle(hwndParent,&rcl);
	HANDLES.hWndTreeView = CreateWindowEx(
        0L,
		WC_TREEVIEW,               
		"",                         
		WS_VISIBLE | WS_CHILD | WS_BORDER | TVS_HASLINES |
		   TVS_HASBUTTONS | TVS_LINESATROOT | WS_EX_CLIENTEDGE,
        0, 27,						
        (rcl.right - rcl.left)/4,	
        (rcl.bottom - rcl.top),	
		hwndParent,					
		(HMENU) ID_TREEVIEW,		
		HANDLES.hInst,						
		NULL );
	if (!HANDLES.hWndTreeView) return FALSE;
	//  
	HIMAGELIST hSmall;
	HICON hIcon;
	hSmall = ImageList_Create( 16, 16, FALSE , 3, 3 );
	if(!hSmall)
		return FALSE;
	hIcon = LoadIcon(HANDLES.hInst,MAKEINTRESOURCE(IDI_COLLECTION));
	int t=ImageList_AddIcon(hSmall, hIcon,NULL);
	hIcon = LoadIcon(HANDLES.hInst,MAKEINTRESOURCE(IDI_DISK));
	t=ImageList_AddIcon(hSmall, hIcon,NULL);
	hIcon = LoadIcon(HANDLES.hInst,MAKEINTRESOURCE(IDI_ALBUM));
	t=ImageList_AddIcon(hSmall, hIcon,NULL);
	int c=ImageList_GetImageCount(hSmall);
	//      
	TreeView_SetImageList(HANDLES.hWndTreeView, hSmall, 0);

	return TRUE;
}

HTREEITEM TV_InsertItem( LPSTR szText, HWND hwndTree,HTREEITEM hTPrev,int iImage,int index)
{
	//     
	HTREEITEM hItem;
	TV_ITEM tvI;
	ZeroMemory(&tvI,sizeof(TV_ITEM));
	TV_INSERTSTRUCT tvIns;
	ZeroMemory(&tvIns,sizeof(TV_INSERTSTRUCT));
	tvI.mask = TVIF_TEXT | TVIF_IMAGE | TVIF_SELECTEDIMAGE | TVIF_PARAM;
	tvI.pszText = szText;
	tvI.cchTextMax = lstrlen(szText);
	tvI.iImage = iImage;
    tvI.iSelectedImage = iImage;
    tvI.lParam = index;  
	tvIns.item = tvI;
    tvIns.hParent = hTPrev;
	//    
	hItem = (HTREEITEM)SendMessage(hwndTree, TVM_INSERTITEM, 0, 
		(LPARAM)(LPTV_INSERTSTRUCT)&tvIns);
    if (hItem == NULL)
        MessageBox(NULL, "   ", NULL, MB_OK);
	return (hItem);
}

BOOL TV_DeleteItem(int index)
{
	HTREEITEM hItem;
	int pos;
	for (int i=0;i<dwWkCount;i++)
		if (WkRec[i].ind==index)
			pos=i;
	return TreeView_DeleteItem(HANDLES.hWndTreeView, WkRec[pos].hTree);
}

BOOL TV_DeleteAll()
{
	return TreeView_DeleteAllItems(HANDLES.hWndTreeView);
}

	char buf[10]; char* toString(int value,int radix=10){
	itoa(value,buf,radix);
	return buf;};

LRESULT TV_NotifyHandler( HWND hWnd, UINT uMsg, 
						 WPARAM wParam, LPARAM lParam)
{
    static NM_TREEVIEW *pNm;
	int i,stat;
    pNm = (NM_TREEVIEW *)lParam;

    if (wParam != ID_TREEVIEW)
		return 0L;
int j;
    switch(pNm->hdr.code)
	{
        case TVN_SELCHANGED:
            for (i=0;i<dwWkCount;i++)
			{
				if ((pNm->itemNew.lParam)==WkRec[i].ind)
					stat=i;
			}
			
					
			
			switch (WkRec[stat].iType)
			{
				case 0:
		
					HANDLES.iSelDisk=(pNm->itemNew.lParam);
					MakeList(HANDLES.iSelDisk);
					break;
				case 1:
					
					HANDLES.iSelTrack=(pNm->itemNew.lParam);

					LV_RemoveAllItems(HANDLES.hWndListView);
			//		MessageBox(NULL,WkRec[stat].cTrack,"1",NULL);
					LV_AddItem(HANDLES.hWndListView,0,"123",&WkRec[stat]);
					

				//	LV_AddItem(HANDLES.hWndListView,1,"123",WorkRecord *param);

				//	MessageBox(NULL,toString(HANDLES.iSelTrack),"",NULL);
					//if (!PropHandle)
					//	PropHandle=(HWND) CreatePropertySheet(hWnd,1);
					break;
				default:
					LV_RemoveAllItems(HANDLES.hWndListView);
			}
			GetStateOfCommonControls();
			return 1;
            break;
		default:
			break;
	}
	return 0L;
}


